	/*  Global variables  */

extern float
	SAMPLE,
	MINACCURACY,
	MINALTFRAC,
	DETERMINATE;

extern int
	MAXPOSSLIT,
	MAXALTS,
	MAXVARDEPTH,
	MAXTUPLES,
	Verbosity,			/* level of output */
	MaxConst,			/* no. constants */
	MaxTC,                          /* no. of theory constants */
	MaxType,			/* no. types */
	MaxVar,				/* no. variables in training set */
        NewMaxVar,                      /*  ditto for new training set */
	OldMaxVar,			/*  ... prior to new literal(s) */
	MaxRel,				/* highest relation no */
	Pos, CyclePos,			/* no. pos cases in training set */
        NewPos,                         /*  ditto for new training set */
	OrigPosCov,                     /* no. original pos cases covered */
	Tot, InitialTot, CycleTot,	/* no. cases in training set */
        NewTot,                         /* ditto for new training set */
	OrigTotCov,                     /* no. original cases covered */
	NewSize,			/* size of next training set */
	NCl,				/* current clause number */
	NLit,				/* current literal number */
	NDeterminate,
	WeakLiterals,			/* no. no-gain/non-discrim literals */
	Tried,
        ADC,                            /* All Det Clause counter */
	PossibleRelns,			/* no. relations with possible args */
	*PossibleArgLists,		/* the numbers of possible args */
	EqualityRelnArgs,		/* For coding TCs as part of = */
	NRecLitCl,                      /* Number of recursive literals */
	NRecLitDef,                     /* Ditto prior to current clause */
	CompactClCover,			/* No. covered by compact clause */
	CompactClNLit;

extern Relation
	*Reln,           		/* relations */
	*RelnOrder,     		/* order to try relations */
	Target;				/* relation being induced */

extern Tuples
	TrainingSet,			/* tuples in current training set */
        NewTS,                          /* tuples in new training set */
	InitialTrainingSet,		/* copy at start of first clause */
	CopyTrainingSet;		/* copy at start of current clause */

extern Clause
	NewClause,			/* clause being constructed */
        *AllDeterminateClause,          /* clause prior to first non-det lit
                                           - as series of sub-clauses */
	CompactClause;                  /* best shorter clause discovered 
					   while developing current clause */
	
extern float
	*LogFact,
	BaseInfo,
	InitialBaseInfo,
        OldBaseInfo,
	MaxPossibleGain,
	UsedSoFar,			/* bits in previous literals */
	AvailableBits;			/* bits available for this clause */

extern Boolean
	NEGLITERALS,
        RECURSIVEINTERP,        /* Test cases to be interpreted
                                           recursively ? */
        FASTFORWARD,            /* Clauses to be bootstrapped up with
                                   initial determinate literals from
                                   preceding clause */

        RecursChecking,         /* Recursive checking currently on ? */

	AnyPartialOrder,
	*PartialOrderOK,
        AllCovered,
	**Compatible,
	**ExtCompatible,
	**DefinitionOrders,
	**ClauseOrders,
	*TypeOrdered,
	**TypeOrderCl,
	**TypeOrderDef,
	ArgOrderedCl[MAXARITY+1],
	ArgOrderedDef[MAXARITY+1];

extern Ordering
	PartialOrder[MAXARITY+1][MAXARITY+1],/* partial orders on variables */
	**RecLitCl,		/* Argument order info for recursive lits */
	**RecLitDef;		/* ditto prior to current clause */

extern char
	Name[200],
	ArgList[MAXARITY+1],
        *VariableName[MAXARITY+1],      /* variable name array */
	SectionDelim,
        DefVars[],                      /* array of numbers 0 to MAXARITY */
	**ConstName,
	*Bits;

extern Const
	*SortedConst,
        Value[MAXARITY+1];

extern TypeInfo
	*Type;

extern VarInfo
        *Variable;                       /* variable array */

extern TCInfo
        *TheoryConst;

extern Tuples
	Found;
extern int
	NFound;

extern Alternative
	*ToBeTried;
extern int
	NToBeTried;

extern PossibleLiteral
	*Possible;
extern int
	NPossible;
